package Labirinto;
import java.io.EOFException;

import Pila.EccezioneStrutturaVuota;
import Pila.PilaCollegata;

public class Labirinto {
	private int[][] grid = {{1,1,0,1,1},
							{1,0,1,1,1},
							{1,1,1,0,1},
							{1,0,0,1,1},
							{0,1,1,1,1}};
	private PilaCollegata<Posizione> pila = new PilaCollegata<Posizione>();
	//dimensione labirinto
	
	public boolean attraversa(Posizione iniz,Posizione fin) {
		pila.push(iniz);
		//imposta come gi visitato
		grid[iniz.getX()][iniz.getY()] = 3;
		if (iniz.equals(fin)) return true; 
		//controlla se fin  raggiungibile dalla posiz. sotto quella corrente
		if (valido(iniz.getX()+1,iniz.getY()))
			if (attraversa(new Posizione(iniz.getX()+1,iniz.getY()),fin))
				return true;
		//controlla se fin  raggiungibile dalla posiz. sopra quella corrente
		if (valido(iniz.getX()-1,iniz.getY()))
			if (attraversa(new Posizione(iniz.getX()-1,iniz.getY()),fin))
				return true;
	    //controlla se fin  raggiungibile dalla posiz. a destra della posiz. corrente
		if (valido(iniz.getX(),iniz.getY()+1))
			if (attraversa(new Posizione(iniz.getX(),iniz.getY()+1),fin))
				return true;
		//controlla se fin  raggiungibile dalla posiz. a sinistra della posiz. corrente
		if (valido(iniz.getX(),iniz.getY()-1))
			if (attraversa(new Posizione(iniz.getX(),iniz.getY()-1),fin))
				return true;
		if (!pila.isEmpty())
		     pila.pop();
		return false;
		
	}
	
	public boolean valido(int riga,int colonna){
		//verifica se la posizione  fuori dai margini
		if (riga < 0 || riga >= grid.length || colonna < 0 || colonna >= grid[0].length) return false;
		int val = grid[riga][colonna];
		if (val == 3 || val == 0)
			return false;
		return true;
	}
	
	
	
	public static void main(String[] args) {
		Posizione iniz = new Posizione(0,0);
		Posizione fin = new Posizione(4,4);
		Labirinto maze = new Labirinto();
		
		if (maze.attraversa(iniz,fin)) {
			System.out.println("Il labirinto ha una soluzione.");
			System.out.println("Il percorso da " + fin + " a " + iniz + "  il seguente:");
			while (!maze.pila.isEmpty())
			{
				try {
					System.out.println(maze.pila.top());
					maze.pila.pop();
				} catch (EccezioneStrutturaVuota e) {
					e.printStackTrace();
				}
			}
		}
		else
			System.out.println("Il labirinto non ha una soluzione");
	}

}
